/// <reference types="node" />
type EventHintOrCaptureContext =
  | {
      [key: string]: any
    }
  | Function
declare class AuthError extends Error {}
declare class InputError extends Error {
  body: string | undefined
  constructor(message: string, body?: string)
}
declare function captureException(
  exception: unknown,
  hint?: EventHintOrCaptureContext | undefined
): Promise<string>
declare function captureExceptionSync(
  exception: unknown,
  hint?: EventHintOrCaptureContext | undefined
): string
declare function isErrnoException(
  value: unknown
): value is NodeJS.ErrnoException
export {
  AuthError,
  InputError,
  captureException,
  captureExceptionSync,
  isErrnoException
}
