/// <reference types="node" />
import { Remap } from '@socketsecurity/registry/lib/objects'
import { Abortable } from 'node:events'
import {
  ObjectEncodingOptions,
  OpenMode,
  PathLike,
  PathOrFileDescriptor
} from 'node:fs'
import { FileHandle } from 'node:fs/promises'
declare function removeNodeModules(cwd?: string): Promise<void>
type FindUpOptions = {
  cwd?: string | undefined
  signal?: AbortSignal | undefined
}
declare function findUp(
  name: string | string[],
  { cwd, signal }: FindUpOptions
): Promise<string | undefined>
type ReadFileOptions = Remap<
  ObjectEncodingOptions &
    Abortable & {
      flag?: OpenMode | undefined
    }
>
declare function readFileBinary(
  filepath: PathLike | FileHandle,
  options?: ReadFileOptions | undefined
): Promise<Buffer>
declare function readFileUtf8(
  filepath: PathLike | FileHandle,
  options?: ReadFileOptions | undefined
): Promise<string>
declare function safeReadFile(
  filepath: PathLike | FileHandle,
  options?:
    | 'utf8'
    | 'utf-8'
    | {
        encoding: 'utf8' | 'utf-8'
      }
    | undefined
): Promise<string | undefined>
declare function safeReadFileSync(
  filepath: PathOrFileDescriptor,
  options?:
    | 'utf8'
    | 'utf-8'
    | {
        encoding: 'utf8' | 'utf-8'
      }
    | undefined
): string | undefined
export {
  removeNodeModules,
  FindUpOptions,
  findUp,
  ReadFileOptions,
  readFileBinary,
  readFileUtf8,
  safeReadFile,
  safeReadFileSync
}
